//   #include <CCSproject.h>, .. h-  , 
//         #device PIC16F84A  h-
//16F84A.h,       .
//  #device PIC16F84A,     
//   : Duplicate #define
//    #include <CCSproject.h>  #device PIC16F84A, 
//,  #DEVICE required before this line

//#include <CCSproject.h>
//=========================    CCSproject.h
//!#include <16F84A.h>
//!
//!#FUSES NOWDT                    //No Watch Dog Timer
//!#FUSES XT                       //Crystal osc <= 4mhz for PCM/PCH , 3mhz to 10 mhz for PCD
//!
//!#use delay(clock=4000000)
//!========================


//=====  16F84A.h,     ,    , 
// 
//////// Standard Header file for the PIC16F84A device ////////////////

#device PIC16F84A

#nolist
//////// Program memory: 1024x14  Data RAM: 68  Stack: 8
//////// I/O: 13   Analog Pins: 0
//////// Data EEPROM: 64
//////// C Scratch area: 0C   ID Location: 2000
//////// Fuses: LP,XT,HS,RC,NOWDT,WDT,PUT,NOPUT,PROTECT,NOPROTECT
//////// 
////////////////////////////////////////////////////////////////// I/O
// Discrete I/O Functions: SET_TRIS_x(), OUTPUT_x(), INPUT_x(),
//                         PORT_x_PULLUPS(), INPUT(),
//                         OUTPUT_LOW(), OUTPUT_HIGH(),
//                         OUTPUT_FLOAT(), OUTPUT_BIT()
// Constants used to identify pins in the above are:
//For example, port a (byte 5 ) bit 3 would have a value of 5*8+3 or 43 . This is defined as follows:  #DEFINE PIN_A3 43

#define PIN_A0  40
#define PIN_A1  41
#define PIN_A2  42
#define PIN_A3  43
#define PIN_A4  44

#define PIN_B0  48
#define PIN_B1  49
#define PIN_B2  50
#define PIN_B3  51
#define PIN_B4  52
#define PIN_B5  53
#define PIN_B6  54
#define PIN_B7  55

////////////////////////////////////////////////////////////////// Useful defines
#define FALSE 0
#define TRUE 1

#define BYTE int8
#define BOOLEAN int1

#define getc getch
#define fgetc getch
#define getchar getch
#define putc putchar
#define fputc putchar
#define fgets gets
#define fputs puts

////////////////////////////////////////////////////////////////// Control
// Control Functions:  RESET_CPU(), SLEEP(), RESTART_CAUSE()
// Constants returned from RESTART_CAUSE() are:
#define WDT_FROM_SLEEP  3     
#define WDT_TIMEOUT     11    
#define MCLR_FROM_SLEEP 16    
#define MCLR_FROM_RUN   27    
#define NORMAL_POWER_UP 27    
#define BROWNOUT_RESTART 26   


////////////////////////////////////////////////////////////////// Timer 0
// Timer 0 (AKA RTCC)Functions: SETUP_COUNTERS() or SETUP_TIMER_0(),
//                              SET_TIMER0() or SET_RTCC(),
//                              GET_TIMER0() or GET_RTCC()
// Constants used for SETUP_TIMER_0() are:
#define T0_INTERNAL   0
#define T0_EXT_L_TO_H 32
#define T0_EXT_H_TO_L 48

#define T0_DIV_1      8
#define T0_DIV_2      0
#define T0_DIV_4      1
#define T0_DIV_8      2
#define T0_DIV_16     3
#define T0_DIV_32     4
#define T0_DIV_64     5
#define T0_DIV_128    6
#define T0_DIV_256    7


#define T0_8_BIT      0     

#define RTCC_INTERNAL   0      // The following are provided for compatibility
#define RTCC_EXT_L_TO_H 32     // with older compiler versions
#define RTCC_EXT_H_TO_L 48
#define RTCC_DIV_1      8
#define RTCC_DIV_2      0
#define RTCC_DIV_4      1
#define RTCC_DIV_8      2
#define RTCC_DIV_16     3
#define RTCC_DIV_32     4
#define RTCC_DIV_64     5
#define RTCC_DIV_128    6
#define RTCC_DIV_256    7
#define RTCC_8_BIT      0     

// Constants used for SETUP_COUNTERS() are the above
// constants for the 1st param and the following for
// the 2nd param:

////////////////////////////////////////////////////////////////// WDT
// Watch Dog Timer Functions: SETUP_WDT() or SETUP_COUNTERS() (see above)
//                            RESTART_WDT()
// WDT base is 18ms
//

#define WDT_18MS        8   
#define WDT_36MS        9   
#define WDT_72MS       10   
#define WDT_144MS      11   
#define WDT_288MS      12   
#define WDT_576MS      13   
#define WDT_1152MS     14   
#define WDT_2304MS     15   


////////////////////////////////////////////////////////////////// INT
// Interrupt Functions: ENABLE_INTERRUPTS(), DISABLE_INTERRUPTS(),
//                      CLEAR_INTERRUPT(), INTERRUPT_ACTIVE(),
//                      EXT_INT_EDGE()
//
// Constants used in EXT_INT_EDGE() are:
#define L_TO_H              0x40
#define H_TO_L                 0
// Constants used in ENABLE/DISABLE_INTERRUPTS() are:
#define GLOBAL                    0x0B80
#define INT_RTCC                  0x000B20
#define INT_RB                    0x00FF0B08
#define INT_EXT_L2H               0x50000B10
#define INT_EXT_H2L               0x60000B10
#define INT_EXT                   0x000B10
#define INT_EEPROM                0x000B40
#define INT_TIMER0                0x000B20

#list

//=====  16F84A.h,     ,    ,   

//.h  MPLAB IDE ,   P16F84A.INC  ASM
//.h  mikroC PRO for PIC .  P16F84A.c
//.h   PIC C Compiler
//#include <16F84A.h>//      (   )  <> (   )
#use delay(clock=4000000) //   PIC C Compiler
#fuses NOWDT,XT, NOPUT, NOPROTECT//original
//#fuses wdt //my popytka
//setup_wdt(WDT_2304MS);//my popytka
//restart_wdt();
#use rs232(baud=9600, xmit=PIN_B2, rcv=PIN_B3) // #use rs232   PIC C Compiler
//,    PIN_B2  PIN_B3 ? :   16F84A.h PIN_B2=50 ( 8), PIN_B3=51 ( 9)
//For example, port a (byte 5 ) bit 3 would have a value of 5*8+3 or 43 . This is defined as follows:  #DEFINE PIN_A3 43
#include "ds18b20.c" //     ds18B20.c
//#include "ds18S20.c" //     ds18S20.c
#include "ds1307.c" //     ds1307.c


//        main()
// #include         ( ,  h) 16F84A.h
//     , ,   
// #include "ds1820.c"       ( .c),     main()
// #include "16F84A.h"      -  ,         
// #include <16F84A.h>     <>-     ,    
// #define -  ()   135
// ,    CCS-PIC C Compiler:   138
// #bit, #byte, #case, #device   139, #fuse   139, #locate, #org, #opt, #priority, #reserve,
// #rom, #type, #use delay, #use XXX_io, #use i2s   144, #use rs232, #zero ram

//    CCS-PIC C   148


void main(void)
{
   int8 i;//,sec,min,hour;    
   int16 tpx,all_tp;
   int8 tp,tpd;
   
   delay_ms(50);
   //init_ds1307(); // initial DS1307
   // set second to 00 and enable clock(bit7=0)
   //write_ds1307(0,0x00);   
   while(true) {    
     printf("===22=====================\r\n");      
     //sec=read_ds1307(0);  // read second
     //min=read_ds1307(1);  // read minute
     //hour=read_ds1307(2); // read houre
     //printf("%02X:%02X:%02X\r\n",hour,min,sec);    
     for (i =0;i<5;i++) 
     {
     printf("%02X\r\n",i);
          all_tp=read_sensor(i);  // read temperature 
          printf("Ch:%u = %Lu\r\n",i+1,all_tp);
       //tpx=all_tp;
       //tp=make8(tpx,1);
       //tpx=all_tp;
       //tpd=make8(tpx,0);       
       //printf("Ch:%u = %03u.%u\r\n",i+1,tp,tpd);       
       delay_ms(500);
   }
   }
}

/*
c Character
s String or character
u Unsigned int
d Signed int
Lu Long unsigned int
Ld Long signed int
x Hex int (lower case)
X Hex int (upper case)
Lx Hex long int (lower case)
LX Hex long int (upper case)
f Float with truncated decimal
g Float with rounded decimal
e Float in exponential format
w Unsigned int with decimal place inserted. Specify two numbers for n. 
The first is a total field width. The second is the desired number of decimal places.

*/
