/*        CCS-PIC C Compiler   
    #use   -
UART\USART    ( 130   ..)
  , -         340

  CCS-PIC C Compiler   (   )  
   :
int1, short -     
int8 -   char
int16 -    int
int32 -    long int

   DS1307
-         (  SDA) ,     SCL
- 0d0 -    DS1307,    ,  0xd1 -   .
-        - (BCD) .  7  0 -     (CH).      1,  .    ,  .
- DS1307    : RTC (00h-07h)  RAM (08h-3Fh)
00h-,  , 01h- , 02-, 03 - , 04 -, 05- , 06- , 07-  (    SQW/OUT.)
      0-3,       ( datasheet) 
- DS1307     2- .
-     :               
*/


#define DS1307_SDA  PIN_B1
#define DS1307_SCL  PIN_B0
#use i2c(master, sda=DS1307_SDA, scl=DS1307_SCL) //  386.         
//CCS-PIC C Compiler : i2c_start(); i2c_write()  .. 

//==========================
// initial DS1307
//==========================
void init_DS1307()  //void-      
{
   output_float(DS1307_SCL);//output_float() -    CCS-PIC C Compiler   350
   output_float(DS1307_SDA);//  pin   
//    
i2c_start();                // 
i2c_write(0xd0);            //     ""
i2c_write(0x00);            //    DS1307
i2c_write(0x00);            //      (00) 
                                 //  (7)    
                                 //("1"- , "0" - )
 i2c_write(0x07);            //    DS1307
i2c_write(0x90);            //   1  SQW/OUT.
                                   //
i2c_stop();                 //
}

//!void init_DS1307 (void)
//!{
//!   i2c_start();                // 
//!   i2c_write(0xd0);            //     ""
//!   i2c_write(0x00);            //    DS1307
//!   i2c_write(0x00);            //      (00) 
//!                                    //  (7)    
//!                                    //("1"- , "0" - )
//!   i2c_write(0x07);            //    DS1307
//!   i2c_write(0x90);            //   1  SQW/OUT.
//!                                    //
//!   i2c_stop();                 //
//!}
//!//==========================
// write data one byte to
// DS1307
//==========================
void write_DS1307(byte address, BYTE data)
{
   short int status;
   i2c_start(); //     I2C.-    CCS-PIC C Compiler
   i2c_write(0xd0);//    $D0 -   DS1307
   i2c_write(address);//     
   i2c_write(data);//        
   i2c_stop();//    
   i2c_start();// 
   status=i2c_write(0xd0);
   while(status==1)
   {
      i2c_start();
      status=i2c_write(0xd0);
   }
}
//==========================
// read data one byte from DS1307
//==========================
BYTE read_DS1307(byte address)
{
   BYTE data;
   i2c_start();
   i2c_write(0xd0);
   i2c_write(address);
   i2c_start();
   i2c_write(0xd1);// $D1 -   DS1307
   data=i2c_read(0);//  0, .. 
   i2c_stop();
   return(data);
}
